#ifndef GLOBAL_H
#define GLOBAL_H

#define NOT_FOUND -1

typedef enum {NA,RU,KR,JP} GameRegion;

// This is the key variable to this process
// it stores the hash bytes (bytes that we will be looking for in the updated meta file)
// and the name of the file and folder we are going to patch
typedef struct
{
    long hash;
    long folderNum;
    long fileNum;
    char* folderName;
    char* fileName;
} FileBlock;

typedef struct
{
    char* bytes;
    long size;
} MemFile;

typedef struct
{
    int* block;
    long size;
} MemFileInt;

typedef struct
{
    char* fileName;
    int patched;
    int totalFails;
} FileToPatch;

extern char* logFileName;
#endif // GLOBAL_H
