#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "file_operations.h"
#include "file_extractor.h"

#define EXIT 0
#define BACK 0
#define MENU_1_MAX_OPTION 6

void menu1(int* menu1_selectedOption, char** filter,char** extractDir);
void menu2(int* menu1_selectedOption, char** filter,char** extractDir);
void menu3(int* menu1_selectedOption, char** filter,char** extractDir);


void printHeader()
{
    printf("******************************************************\n");
    printf("*                                                    *\n");
    printf("*    Black Desert Online File Extractor v1.1         *\n");
    printf("*                                                    *\n");
    printf("******************************************************\n");
}


int main()
{
    char *filter = NULL;
    char *extractDir = NULL;
    int menu1_selectedOption = -1;

    filter = (char*) malloc(MAX_PATH);
    extractDir = (char*) malloc(MAX_PATH);
    extractDir[0] = '\n';
    extractDir[1] = '\0';

    while (menu1_selectedOption != EXIT)
    {
        menu1(&menu1_selectedOption,&filter,&extractDir);

        if (menu1_selectedOption != EXIT)
        {
            // Runs the program
            extractFiles(menu1_selectedOption,filter,extractDir);

            printf("\n");
            system("PAUSE"); // Holds the program so it doesn't close it without pressing a key
        }
    }

    free(filter);
    free(extractDir);
    return 0;
}


void menu1(int* menu1_selectedOption, char** filter, char** extractDir)
{
    (*menu1_selectedOption) = -1;
    char input[MAX_PATH];

    while((*menu1_selectedOption) < 0 || (*menu1_selectedOption) > MENU_1_MAX_OPTION) // This condition makes the menu repeat itself until a valid input is entered
    {
        system("cls"); // Clears the screen
        printHeader();
        printf("What do you want to do?\n\n");
        printf("1 - Extract all files\n");
        printf("2 - Extract textures only \n");
        printf("3 - Extract .PAC files only\n");
        printf("4 - Extract .xml files only\n");
        printf("5 - Extract by extension\n");
        printf("6 - Extract a specific file\n");
        printf("0 - Exit\n") ;
        printf("\nEnter your choice: ");
        fgets(input,MAX_PATH,stdin); // Gets the input from the keyboard
        input[strlen(input) - 1] = '\0';

        // Converts the read string to int
        (*menu1_selectedOption) = atoi(input);

        // If the user entered an invalid option, displays a error message
        if((*menu1_selectedOption) < 0 || (*menu1_selectedOption) > MENU_1_MAX_OPTION)
        {
            printf("\nInvalid option!\n\n");
            system("PAUSE");
        }
    }

    if (menu1_selectedOption != EXIT)
    {
        menu2(menu1_selectedOption,filter,extractDir);
    }
}

void menu2(int* menu1_selectedOption, char** filter, char** extractDir)
{
    int menu2_selectedOption = -1;
    int menu4_selectedOption = -1;
    char input[MAX_PATH] = "";
    switch ((*menu1_selectedOption))
    {
        case(2):
        {
            strcpy((*filter),".dds");
        }break;
        case(3):
        {
            strcpy((*filter),".pac");
        }break;
        case(4):
        {
            strcpy((*filter),".xml");
        }break;
        case(5):
        {
            input[0] = '\n';
            while(input[0] == '\n' || input[0] != '.') // Makes sure that if you just press enter, the program doesn't accept it as a valid folder.
            {
                printf("\nPlease inform the extension of the files you want to extract like this:.xml") ;
                printf("\nExtension: ");
                fgets(input,MAX_PATH,stdin); // Gets the input from the keyboard
                input[strlen(input) - 1] = '\0';

                if (input[0] != '.')
                {
                    printf("\nInvalid input.\n");
                }
            }
            strcpy((*filter),input);
        }break;
        case(6):
        {
            input[0] = '\n';
            while(input[0] == '\n') // Makes sure that if you just press enter, the program doesn't accept it as a valid folder.
            {
                printf("\nPlease inform the name of the file you want to extract, with the extension, all lowercase (E.g.: pew_00_ub_0001.pac)");
                printf("\nFileName: ");
                fgets(input,MAX_PATH,stdin); // Gets the input from the keyboard
                input[strlen(input) - 1] = '\0';
                strcpy((*filter),input);
            }
        }break;

        default:
        {
            while(menu2_selectedOption < 0 || menu2_selectedOption > 2) // This condition makes the menu repeat itself until a valid input is entered
            {
                system("cls"); // Clears the screen
                printHeader();
                printf("Choose the extraction method to be used:\n\n");
                printf("1 - Slow\n");
                printf("2 - Fast \n");
                printf("0 - Back\n") ;
                printf("\nSlow - Extracts 100 percent of the files, but it takes forever.\n");
                printf("\nFast - Extracts 98 percent of the files and it takes way way less time");
                printf("\n       specially if you disable the output (next option)\n");
                  printf("\n   (Warning: 2 percent is around 8000 files that will not be extracted)\n");

                printf("\nEnter your choice: ");
                fgets(input,MAX_PATH,stdin); // Gets the input from the keyboard
                input[strlen(input) - 1] = '\0';

                // Converts the read string to int
                menu2_selectedOption = atoi(input);

                // If the user entered an invalid option, displays a error message
                if(menu2_selectedOption < 0 || menu2_selectedOption > 2)
                {
                    printf("\nInvalid option!\n\n");
                    system("PAUSE");
                }
            }
            if (menu2_selectedOption == 2)
            {
                (*menu1_selectedOption) = 7;

                while(menu4_selectedOption < 0 || menu4_selectedOption > 2) // This condition makes the menu repeat itself until a valid input is entered
                {
                    system("cls"); // Clears the screen
                    printHeader();
                    printf("Please select one of the options:\n\n");
                    printf("1 - Show output when extracting\n");
                    printf("2 - Suppress output\n");
                    printf("0 - Back\n") ;
                    printf("\nShow output- Prints an output for each file that is extracted.");
                    printf("\n             Takes more time to extract but you can see the program \"working\"\n");
                    printf("\nSuppress output - Extracts way faster, but you don't see any \"Progress bar\" or anything.");
                    printf("\n                  You will only know the program is done when the \"Finished\" message shows up.\n");
                    printf("\nEnter your choice: ");
                    fgets(input,MAX_PATH,stdin); // Gets the input from the keyboard
                    input[strlen(input) - 1] = '\0';

                    // Converts the read string to int
                    menu4_selectedOption = atoi(input);

                    // If the user entered an invalid option, displays a error message
                    if(menu4_selectedOption < 0 || menu4_selectedOption > 2)
                    {
                        printf("\nInvalid option!\n\n");
                        system("PAUSE");
                    }

                    if (menu4_selectedOption == 2)
                    {
                        (*menu1_selectedOption) = 8;
                    }
                }
            }
        };
    }
    if (menu2_selectedOption == BACK)
    {
        menu1(menu1_selectedOption,filter,extractDir);
    }
    else
    {
        menu3(menu1_selectedOption,filter,extractDir);
    }
}

void menu3(int* menu1_selectedOption, char** filter, char** extractDir)
{
    char input[MAX_PATH];
    int menu3_selectedOption = -1;
    while(menu3_selectedOption < 0 || menu3_selectedOption > 2) // This condition makes the menu repeat itself until a valid input is entered
    {
        system("cls"); // Clears the screen
        printHeader();
        printf("Where do you want the files to be extracted\n\n");
        printf("1 - Black Desert\'s root folder\n");
        printf("2 - Different location \n");
        printf("0 - Back\n") ;
        printf("\nEnter your choice: ");
        fgets(input,MAX_PATH,stdin); // Gets the input from the keyboard
        input[strlen(input) - 1] = '\0';

        // Converts the read string to int
        menu3_selectedOption = atoi(input);

        // If the user entered an invalid option, displays a error message
        if(menu3_selectedOption < 0 || menu3_selectedOption > 2)
        {
            printf("\nInvalid option!\n\n");
            system("PAUSE");
        }
    }

    if (menu3_selectedOption == 1)
    {
        /* Creates the full string, based on the current folder. Eg: C:\Program Files (x86)\Black Desert Online\Paz becomes C:\Program Files (x86)\Black Desert Online\ */
        (*extractDir) = oneLevelDown(getCurrentPath());
    }
    else if (menu3_selectedOption == 2)
    {
        input[0] = '\n';
        while(input[0] == '\n' || (input[2] != '\\' && input[2] != '/')) // Makes sure that if you just press enter, the program doesn't accept it as a valid folder.
        {
            printf("\nPlease paste here the full path you want to extract the files: (E.g.: C:\\Extracted Files\\)") ;
            printf("\nPATH: ");
            fgets(input,MAX_PATH,stdin); // Gets the input from the keyboard
            input[strlen(input) - 1] = '\0';

            if (input[2] != '\\' && input[2] != '/')
            {
                printf("\nInvalid input.\n");
            }
        }
        strcpy((*extractDir),input);
    }
    if (menu3_selectedOption == BACK)
    {
        menu1(menu1_selectedOption,filter,extractDir);
    }
}



